# -*- coding: utf-8 -*-


from django.db import models, migrations
import django.utils.timezone
from django.conf import settings


class Migration(migrations.Migration):

    dependencies = [
        ('ISS', '0005_poster_normalized_username'),
    ]

    operations = [
        migrations.CreateModel(
            name='ForumFlag',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('last_read_date', models.DateTimeField(null=True)),
            ],
        ),
        migrations.AddField(
            model_name='forum',
            name='last_update',
            field=models.DateTimeField(default=django.utils.timezone.now),
        ),
        migrations.AlterField(
            model_name='post',
            name='created',
            field=models.DateTimeField(default=django.utils.timezone.now),
        ),
        migrations.AlterField(
            model_name='thread',
            name='created',
            field=models.DateTimeField(default=django.utils.timezone.now),
        ),
        migrations.AlterField(
            model_name='thread',
            name='last_update',
            field=models.DateTimeField(default=django.utils.timezone.now),
        ),
        migrations.AddField(
            model_name='forumflag',
            name='forum',
            field=models.ForeignKey(to='ISS.Forum', on_delete=models.CASCADE),
        ),
        migrations.AddField(
            model_name='forumflag',
            name='poster',
            field=models.ForeignKey(to=settings.AUTH_USER_MODEL, on_delete=models.CASCADE),
        ),
        migrations.AlterUniqueTogether(
            name='forumflag',
            unique_together=set([('forum', 'poster')]),
        ),
    ]
